Index: emacs/lisp/ns-menu-bar.el
diff -c /dev/null emacs/lisp/ns-menu-bar.el:1.4
*** /dev/null	Fri Aug  2 20:40:25 1996
--- emacs/lisp/ns-menu-bar.el	Fri Aug  2 03:55:56 1996
***************
*** 0 ****
--- 1,609 ----
+ ;;; ns-menu-bar.el --- define a default menu bar for NS users
+ 
+ ;; Author: Carl Edman
+ ;; Keywords: internal
+ ;; Maintainer: Christian Limpach <chris@nice.ch>
+ 
+ ;; Copyright (C) 1993 Free Software Foundation, Inc.
+ 
+ ;; This file is part of GNU Emacs.
+ 
+ ;; GNU Emacs is free software; you can redistribute it and/or modify
+ ;; it under the terms of the GNU General Public License as published by
+ ;; the Free Software Foundation; either version 2, or (at your option)
+ ;; any later version.
+ 
+ ;; GNU Emacs is distributed in the hope that it will be useful,
+ ;; but WITHOUT ANY WARRANTY; without even the implied warranty of
+ ;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ ;; GNU General Public License for more details.
+ 
+ ;; You should have received a copy of the GNU General Public License
+ ;; along with GNU Emacs; see the file COPYING.  If not, write to
+ ;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ 
+ ;;; Code:
+ 
+ (require 'cl)
+ (require 'ispell)
+ 
+ ;; Don't clobber an existing menu-bar keymap, to preserve any menu-bar key
+ ;; definitions made in loaddefs.el.
+ (or (lookup-key global-map [menu-bar])
+     (define-key global-map [menu-bar] (make-sparse-keymap "menu-bar")))
+ 
+ (setq menu-bar-final-items '(buffers windows services hide-app quit))
+ 
+ (define-key global-map [menu-bar quit] '("Quit" . save-buffers-kill-emacs))
+ (define-key global-map [menu-bar hide-app] '("Hide" . do-hide-emacs))
+ (define-key global-map [menu-bar services] (cons "Services" (make-sparse-keymap "Services")))
+ (define-key global-map [menu-bar windows] (make-sparse-keymap "Windows"))
+ (define-key global-map [menu-bar buffers] (make-sparse-keymap "Buffers"))
+ 
+ (defvar menu-bar-tools-menu (make-sparse-keymap "Tools"))
+ (define-key global-map [menu-bar tools] (cons "Tools" menu-bar-tools-menu))
+ 
+ (defvar menu-bar-search-menu (make-sparse-keymap "Search"))
+ (define-key global-map [menu-bar search] (cons "Search" menu-bar-search-menu))
+ 
+ (defvar menu-bar-edit-menu (make-sparse-keymap "Edit"))
+ (define-key global-map [menu-bar edit] (cons "Edit" menu-bar-edit-menu))
+ 
+ (defvar menu-bar-files-menu (make-sparse-keymap "File"))
+ (define-key global-map [menu-bar files] (cons "File" menu-bar-files-menu))
+ ;; This alias is for compatibility with 19.28 and before.
+ (defvar menu-bar-file-menu menu-bar-files-menu)
+ 
+ (defvar menu-bar-help-menu (make-sparse-keymap "Info"))
+ (define-key global-map [menu-bar help-menu] (cons "Info" menu-bar-help-menu))
+ 
+ (defvar vc-menu-map (make-sparse-keymap "Version Control"))
+ 
+ (define-key menu-bar-tools-menu [calendar] '("Display Calendar" . calendar))
+ (define-key menu-bar-tools-menu [rmail] '("Read Mail" . rmail))
+ (define-key menu-bar-tools-menu [gnus] '("Read Net News" . gnus))
+ 
+ (define-key menu-bar-tools-menu [vc-menu]
+   (cons "Version Control" vc-menu-map))
+ 
+ (define-key menu-bar-tools-menu [epatch]
+   (cons "Apply Patch" menu-bar-epatch-menu))
+ (define-key menu-bar-tools-menu [ediff-merge]
+   (cons "Merge" menu-bar-ediff-merge-menu))
+ (define-key menu-bar-tools-menu [compare]
+   (cons "Compare" menu-bar-ediff-menu))
+ 
+ (put 'print-region 'menu-enable 'mark-active)
+ (put 'ps-print-region-with-faces 'menu-enable 'mark-active)
+ 
+ (define-key menu-bar-tools-menu [ps-print-region]
+   '("Postscript Print Region" . ps-print-region-with-faces))
+ (define-key menu-bar-tools-menu [ps-print-buffer]
+   '("Postscript Print Buffer" . ps-print-buffer-with-faces))
+ (define-key menu-bar-tools-menu [print-region]
+   '("Print Region" . print-region))
+ (define-key menu-bar-tools-menu [print-buffer]
+   '("Print Buffer" . print-buffer))
+ ;(define-key menu-bar-user-menu [gomoku] '("Gomoku" . gomoku))
+ ;(define-key menu-bar-user-menu [hanoi] '("Hanoi" . hanoi))
+ ;(define-key menu-bar-user-menu [doktor] '("Doctor" . doctor))
+ 
+ (define-key menu-bar-files-menu [one-window]
+   '("One Window" . delete-other-windows))
+ (define-key menu-bar-files-menu [split-window]
+   '("Split Window" . split-window-vertically))
+ (define-key menu-bar-files-menu [kill-buffer]
+   '("Kill Current Buffer" . kill-this-buffer))
+ (define-key menu-bar-files-menu [insert-file]
+   '("Insert File..." . insert-file))
+ (define-key menu-bar-files-menu [revert-buffer]
+   '("Revert Buffer" . revert-buffer))
+ (define-key menu-bar-files-menu [write-file]
+   '("Save Buffer As..." . write-file))
+ (define-key menu-bar-files-menu [save-buffer] '("Save Buffer" . save-buffer))
+ (define-key menu-bar-files-menu [dired] '("Open Directory..." . dired))
+ (define-key menu-bar-files-menu [open-file]
+   '("Open File..." . find-file-other-frame))
+ 
+ ;; This is just one element of the ediff menu--the first.
+ (define-key menu-bar-ediff-menu [window]
+   '("This Window And Next Window" . compare-windows))
+ 
+ (defun nonincremental-search-forward (string)
+   "Read a string and search for it nonincrementally."
+   (interactive "sSearch for string: ")
+   (if (equal string "")
+       (search-forward (car search-ring))
+     (isearch-update-ring string nil)
+     (search-forward string)))
+ 
+ (defun nonincremental-search-backward (string)
+   "Read a string and search backward for it nonincrementally."
+   (interactive "sSearch for string: ")
+   (if (equal string "")
+       (search-backward (car search-ring))
+     (isearch-update-ring string nil)
+     (search-backward string)))
+ 
+ (defun nonincremental-re-search-forward (string)
+   "Read a regular expression and search for it nonincrementally."
+   (interactive "sSearch for regexp: ")
+   (if (equal string "")
+       (re-search-forward (car regexp-search-ring))
+     (isearch-update-ring string t)
+     (re-search-forward string)))
+ 
+ (defun nonincremental-re-search-backward (string)
+   "Read a regular expression and search backward for it nonincrementally."
+   (interactive "sSearch for regexp: ")
+   (if (equal string "")
+       (re-search-backward (car regexp-search-ring))
+     (isearch-update-ring string t)
+     (re-search-backward string)))
+ 
+ (defun nonincremental-repeat-search-forward ()
+   "Search forward for the previous search string."
+   (interactive)
+   (search-forward (car search-ring)))
+ 
+ (defun nonincremental-repeat-search-backward ()
+   "Search backward for the previous search string."
+   (interactive)
+   (search-backward (car search-ring)))
+ 
+ (defun nonincremental-repeat-re-search-forward ()
+   "Search forward for the previous regular expression."
+   (interactive)
+   (re-search-forward (car regexp-search-ring)))
+ 
+ (defun nonincremental-repeat-re-search-backward ()
+   "Search backward for the previous regular expression."
+   (interactive)
+   (re-search-backward (car regexp-search-ring)))
+ 
+ (define-key menu-bar-search-menu [query-replace-regexp]
+   '("Query Replace Regexp..." . query-replace-regexp))
+ (define-key menu-bar-search-menu [query-replace]
+   '("Query Replace..." . query-replace))
+ (define-key menu-bar-search-menu [find-tag]
+   '("Find Tag..." . find-tag))
+ (put 'find-tag 'menu-enable 'tags-table-list)
+ (define-key menu-bar-search-menu [bookmark]
+   (cons "Bookmarks" menu-bar-bookmark-map))
+ 
+ (define-key menu-bar-search-menu [nonincremental-repeat-re-search-back]
+   '("Repeat Regexp Backwards" . nonincremental-repeat-re-search-backward))
+ (define-key menu-bar-search-menu [nonincremental-repeat-search-back]
+   '("Repeat Backwards" . nonincremental-repeat-search-backward))
+ (define-key menu-bar-search-menu [nonincremental-repeat-re-search-fwd]
+   '("Repeat Regexp" . nonincremental-repeat-re-search-forward))
+ (define-key menu-bar-search-menu [nonincremental-repeat-search-fwd]
+   '("Repeat Search" . nonincremental-repeat-search-forward))
+ 
+ (define-key menu-bar-search-menu [re-search-back]
+   '("Regexp Search Backwards..." . nonincremental-re-search-backward))
+ (define-key menu-bar-search-menu [search-back]
+   '("Search Backwards..." . nonincremental-search-backward))
+ (define-key menu-bar-search-menu [re-search-fwd]
+   '("Regexp Search..." . nonincremental-re-search-forward))
+ (define-key menu-bar-search-menu [search-fwd]
+   '("Search..." . nonincremental-search-forward))
+ 
+ (if (fboundp 'start-process)
+     (define-key menu-bar-edit-menu [spell] '("Spell" . ispell-menu-map)))
+ (define-key menu-bar-edit-menu [fill] '("Fill" . fill-region))
+ (define-key menu-bar-edit-menu [props] (cons "Text Properties" facemenu-menu))
+ (define-key menu-bar-edit-menu [clear] '("Clear" . delete-region))
+ 
+ (defvar yank-menu (make-sparse-keymap "Select and Paste"))
+ (define-key menu-bar-edit-menu [select-paste]
+   (cons "Select and Paste" yank-menu))
+ (define-key menu-bar-edit-menu [paste] '("Paste" . yank))
+ (define-key menu-bar-edit-menu [copy] '("Copy" . menu-bar-kill-ring-save))
+ (define-key menu-bar-edit-menu [cut] '("Cut" . kill-region))
+ (define-key menu-bar-edit-menu [undo] '("Undo" . undo))
+ 
+ (defun menu-bar-kill-ring-save (beg end)
+   (interactive "r")
+   (if (mouse-region-match)
+       (message "Select a region with the mouse does `copy' automatically")
+     (kill-ring-save beg end)))
+ 
+ (put 'fill-region 'menu-enable 'mark-active)
+ (put 'kill-region 'menu-enable 'mark-active)
+ (put 'menu-bar-kill-ring-save 'menu-enable 'mark-active)
+ (put 'yank 'menu-enable '(selection-exists-p))
+ (put 'yank-menu 'menu-enable '(cdr yank-menu))
+ (put 'delete-region 'menu-enable '(and mark-active
+ 				       (not (mouse-region-match))))
+ (put 'undo 'menu-enable '(if (eq last-command 'undo)
+ 			     pending-undo-list
+ 			   (consp buffer-undo-list)))
+ (put 'query-replace 'menu-enable '(not buffer-read-only))
+ 
+ (autoload 'ispell-menu-map "ispell" nil t 'keymap)
+ 
+ (define-key menu-bar-help-menu [emacs-version]
+   '("Show Version" . emacs-version))
+ (define-key menu-bar-help-menu [ns-bug-report]
+   '("Report NeXTstep bug" . ns-submit-bug-report))
+ (define-key menu-bar-help-menu [report-emacs-bug]
+   '("Report General Emacs bug..." . report-emacs-bug))
+ (define-key menu-bar-help-menu [emacs-tutorial]
+   '("Emacs Tutorial" . help-with-tutorial))
+ (define-key menu-bar-help-menu [emacs-faq]
+   '("Emacs FAQ" . view-emacs-FAQ))
+ (define-key menu-bar-help-menu [emacs-news]
+   '("Emacs News" . view-emacs-news))
+ (define-key menu-bar-help-menu [man] '("Man..." . manual-entry))
+ (define-key menu-bar-help-menu [describe-variable]
+   '("Describe Variable..." . describe-variable))
+ (define-key menu-bar-help-menu [describe-function]
+   '("Describe Function..." . describe-function))
+ (define-key menu-bar-help-menu [describe-key]
+   '("Describe Key..." . describe-key))
+ (define-key menu-bar-help-menu [list-keybindings]
+   '("List Keybindings" . describe-bindings))
+ (define-key menu-bar-help-menu [command-apropos]
+   '("Command Apropos..." . command-apropos))
+ (define-key menu-bar-help-menu [describe-mode]
+   '("Describe Mode" . describe-mode))
+ (define-key menu-bar-help-menu [save-preferences]
+   '("Save Preferences" . ns-save-preferences))
+ (define-key menu-bar-help-menu [info-ns]
+   '("Info about Emacs for NS" . info-ns-emacs))
+ (define-key menu-bar-help-menu [info] '("Browse Manuals" . info))
+ 
+ (defun info-ns-emacs ()         ; for the menubar as well
+   "Jump to ns-emacs info item."
+   (interactive)
+   (info "ns-emacs"))
+ 
+ (defun kill-this-buffer ()	; for the menubar
+   "Kills the current buffer."
+   (interactive)
+   (kill-buffer (current-buffer)))
+ 
+ (defun kill-this-buffer-enabled-p ()
+   (let ((count 0)
+ 	(buffers (buffer-list)))
+     (while buffers
+       (or (string-match "^ " (buffer-name (car buffers)))
+ 	  (setq count (1+ count)))
+       (setq buffers (cdr buffers)))
+     (and (not (window-minibuffer-p (selected-window)))
+ 	 (> count 1))))
+ 
+ (put 'kill-this-buffer 'menu-enable '(kill-this-buffer-enabled-p))
+ 
+ (put 'save-buffer 'menu-enable
+      '(and (buffer-modified-p)
+ 	   (not (window-minibuffer-p (selected-window)))))
+ 
+ (put 'write-file 'menu-enable
+      '(not (window-minibuffer-p (selected-window))))
+ 
+ (put 'find-file 'menu-enable
+      '(not (window-minibuffer-p (selected-window))))
+ 
+ (put 'dired 'menu-enable
+      '(not (window-minibuffer-p (selected-window))))
+ 
+ (put 'insert-file 'menu-enable
+      '(not (window-minibuffer-p (selected-window))))
+ 
+ (put 'revert-buffer 'menu-enable
+      '(or revert-buffer-function revert-buffer-insert-file-contents-function
+ 	  (and (buffer-file-name)
+ 	       (or (buffer-modified-p)
+ 		   (not (verify-visited-file-modtime (current-buffer)))))))
+ 
+ ;; Permit deleting frame if it would leave a visible or iconified frame.
+ (put 'delete-frame 'menu-enable
+      '(delete-frame-enabled-p))
+ 
+ (defun delete-frame-enabled-p ()
+   "Return non-nil if `delete-frame' should be enabled in the menu bar."
+   (let ((frames (frame-list))
+ 	      (count 0))
+ 	  (while frames
+ 	    (if (frame-visible-p (car frames))
+ 		(setq count (1+ count)))
+ 	    (setq frames (cdr frames)))
+ 	  (> count 1)))
+ 
+ (put 'advertised-undo 'menu-enable
+      '(and (not (eq t buffer-undo-list))
+ 	   (if (eq last-command 'undo)
+ 	       (and (boundp 'pending-undo-list)
+ 		    pending-undo-list)
+ 	     buffer-undo-list)))
+ 
+ (defvar yank-menu-length 43
+   "*Maximum length to display in the yank-menu.")
+ 
+ (defun menu-bar-update-yank-menu (string old)
+   (let* ((front (car (cdr yank-menu)))
+ 	 ;; build menu-string
+ 	 ;; replace newlines by dots
+ 	 ;; and shorten the string to yank-menu-length
+ 	 (menu-string (let ((res string) (pos -1))
+ 			(while (setq pos (string-match "\n" res (1+ pos)))
+ 			  (setq res (replace-match "." nil t res)))
+ 			(if (string-match "\\.*$" res)
+ 			    (setq res (replace-match "" nil t res)))))
+          (menu-string (if (<= (length menu-string) yank-menu-length)
+                           menu-string
+                         (concat
+                          (substring menu-string 0 (/ yank-menu-length 2))
+                          "..."
+                          (substring menu-string (- (/ yank-menu-length 2)))))))
+     ;; If we're supposed to be extending an existing string, and that
+     ;; string really is at the front of the menu, then update it in place.
+     (if (and old (or (eq old (car front))
+ 		     (string= old (car front))))
+ 	(progn
+ 	  (setcar front string)
+ 	  (setcar (cdr front) menu-string))
+       (setcdr yank-menu
+ 	      (cons
+ 	       (cons string (cons menu-string 'menu-bar-select-yank))
+ 	       (cdr yank-menu)))))
+   (if (> (length (cdr yank-menu)) kill-ring-max)
+       (setcdr (nthcdr kill-ring-max yank-menu) nil)))
+ 
+ (defun menu-bar-select-yank ()
+   (interactive "*")
+   (push-mark (point))
+   (insert last-command-event))
+ 
+ (defvar complex-buffers-menu-p nil
+   "*Non-nil says, offer a choice of actions after you pick a buffer.
+ This applies to the Buffers menu from the menu bar.")
+ 
+ (defvar buffers-menu-max-size 10
+   "*Maximum number of entries which may appear on the Buffers menu.
+ If this is 10, then only the ten most-recently-selected buffers are shown.
+ If this is nil, then all buffers are shown.
+ A large number or nil slows down menu responsiveness.")
+ 
+ (defvar list-buffers-directory nil)
+ 
+ (defun menu-bar-select-buffer ()
+   (interactive)
+   (switch-to-buffer last-command-event))
+ 
+ (defun menu-bar-update-buffers ()
+   (let* ((buffers (buffer-list))
+          buffers-menu)
+     ;; If requested, list only the N most recently selected buffers.
+     (if (and (integerp buffers-menu-max-size)
+              (> buffers-menu-max-size 1))
+         (if (> (length buffers) buffers-menu-max-size)
+             (setcdr (nthcdr buffers-menu-max-size buffers) nil)))
+     
+     ;; Make the menu of buffers proper.
+     (setq buffers-menu
+           (cons "Select Buffer"
+                 (let ((tail buffers)
+                       (maxbuf 0)
+                       (maxlen 0)
+                       alist
+                       head)
+                   (while tail
+                     (or (eq ?\ (aref (buffer-name (car tail)) 0))
+                         (setq maxbuf
+                               (max maxbuf
+                                    (length (buffer-name (car tail))))))
+                     (setq tail (cdr tail)))
+                   (setq tail buffers)
+                   (while tail
+                     (let ((elt (car tail)))
+                       (or (eq ?\ (aref (buffer-name elt) 0))
+                           (setq alist (cons
+                                        (cons
+                                         (format
+                                          (format "%%%ds  %%s%%s  %%s"
+                                                  maxbuf)
+                                          (buffer-name elt)
+                                          (if (buffer-modified-p elt)
+                                              "*" " ")
+                                          (save-excursion
+                                            (set-buffer elt)
+                                            (if buffer-read-only "%" " "))
+                                          (abbreviate-file-name
+                                           (or (buffer-file-name elt)
+                                               (save-excursion
+                                                 (set-buffer elt)
+                                                 list-buffers-directory)
+                                               "")))
+                                         elt)
+                                        alist)))
+                       (and alist (> (length (car (car alist))) maxlen)
+                            (setq maxlen (length (car (car alist))))))
+                     (setq tail (cdr tail)))
+                   (setq alist (nreverse alist))
+                   (nconc (mapcar '(lambda (pair)
+                                     ;; This is somewhat risque, to use
+                                     ;; the buffer name itself as the event type
+                                     ;; to define, but it works.
+                                     ;; It would not work to use the buffer
+                                     ;; since a buffer as an event has its
+                                     ;; own meaning.
+                                     (nconc (list (buffer-name (cdr pair))
+                                                  (car pair)
+                                                  (cons nil nil))
+                                            'menu-bar-select-buffer))
+                                  alist)
+                          (list (cons 'list-buffers
+                                      (cons
+                                       (concat (make-string (max (- (/ maxlen
+                                                                       2)
+                                                                    8)
+                                                                 0) ?\ )
+                                               "List All Buffers")
+                                       'list-buffers)))))))
+     (if buffers-menu
+         (setq buffers-menu (cons 'keymap buffers-menu)))
+     (define-key global-map [menu-bar buffers]
+       (cons "Buffers" (or buffers-menu 'undefined)))))
+ 
+ (add-hook 'menu-bar-update-fab-hook 'menu-bar-update-buffers)
+ 
+ (defun menu-bar-select-frame ()
+   (interactive)
+   (make-frame-visible last-command-event)
+   (raise-frame last-command-event)
+   (select-frame last-command-event))
+ 
+ ;; ns-arrange functions contributed
+ ;; by Eberhard Mandler <mandler@dbag.ulm.DaimlerBenz.COM>
+ (defun ns-arrange-all-frames ()
+   "Arranges all frames according to topline"
+   (interactive)
+   (ns-arrange-frames t))
+ 
+ (defun ns-arrange-visible-frames ()
+   "Arranges all visible frames according to topline"
+   (interactive)
+   (ns-arrange-frames nil))
+ 
+ (defun ns-arrange-frames ( vis)
+   (let ((frame (next-frame))
+ 	(end-frame (selected-frame))
+ 	(inc-x 20)                      ;relative position of frames
+ 	(inc-y 22)
+ 	(x-pos 100)                     ;start position
+ 	(y-pos 40)
+ 	(done nil))
+     (while (not done)                   ;cycle through all frames
+       (if (not (or vis (eq (frame-visible-p frame) t)))
+ 	(setq x-pos x-pos); do nothing; true case
+ 	(set-frame-position frame x-pos y-pos)
+ 	(setq x-pos (+ x-pos inc-x))
+ 	(setq y-pos (+ y-pos inc-y))
+ 	(raise-frame frame))
+       (select-frame frame)
+       (setq frame (next-frame))
+       (setq done (equal frame end-frame)))
+     (set-frame-position end-frame x-pos y-pos)
+     (raise-frame frame)
+     (select-frame frame)))
+ 
+ (defun menu-bar-update-frames ()
+   (let ((frames (frame-list))
+         (frames-menu (make-sparse-keymap "Windows")))
+     (define-key frames-menu [popup-color-panel]
+       '("Colors..." . ns-popup-color-panel))
+     (define-key frames-menu [popup-font-panel]
+       '("Font Panel..." . ns-popup-font-panel))
+     (mapcar
+      '(lambda (frame)
+         (setcdr frames-menu
+                 (cons
+                  (cons frame
+                        (cons (abbreviate-file-name
+                               (cdr (assq 'name (frame-parameters frame))))
+                              'menu-bar-select-frame))
+                  (cdr frames-menu))))
+      frames)
+     (define-key frames-menu [arrange-all-frames]
+       '("Arrange All Frames" . ns-arrange-all-frames))
+     (define-key frames-menu [arrange-visible-frames]
+       '("Arrange Visible Frames" . ns-arrange-visible-frames))
+     (define-key frames-menu [delete-frame] '("Delete Frame" . delete-frame))
+     (define-key frames-menu [new-frame] '("New Frame" . new-frame))
+     (define-key global-map [menu-bar windows] (cons "Windows" frames-menu))))
+ 
+ (add-hook 'menu-bar-update-fab-hook 'menu-bar-update-frames)
+ 
+ (defun menu-bar-update-frames-and-buffers ()
+   (if (frame-or-buffer-changed-p)
+       (run-hooks 'menu-bar-update-fab-hook)))
+ 
+ (add-hook 'menu-bar-update-hook 'menu-bar-update-frames-and-buffers)
+ 
+ (defvar menu-bar-mode nil)
+ 
+ (defun menu-bar-mode (flag)
+   "Toggle display of a menu bar on each frame.
+ This command applies to all frames that exist and frames to be
+ created in the future.
+ With a numeric argument, if the argument is negative,
+ turn off menu bars; otherwise, turn on menu bars."
+   (interactive "P")
+ 
+ ; ;; Obtain the current setting by looking at default-frame-alist.
+ ; (let ((menu-bar-mode
+ ;        (let ((assq (assq 'menu-bar-lines default-frame-alist)))
+ ;          (if assq (cdr assq) nil))))
+ 
+   ;; Make menu-bar-mode and default-frame-alist consistent.
+   (let ((default (assq 'menu-bar-lines default-frame-alist)))
+     (if default
+         (setq menu-bar-mode (not (eq (cdr default) 0)))
+       (setq default-frame-alist
+             (cons (cons 'menu-bar-lines (if menu-bar-mode 1 0))
+                   default-frame-alist))))
+ 
+   ;; Toggle or set the mode, according to FLAG.
+   (setq menu-bar-mode (if (null flag) (not menu-bar-mode)
+                         (> (prefix-numeric-value flag) 0)))
+ 
+   ;; Apply it to default-frame-alist.
+   (let ((parameter (assq 'menu-bar-lines default-frame-alist)))
+     (if (consp parameter)
+         (setcdr parameter (if menu-bar-mode 1 0))
+       (setq default-frame-alist
+             (cons (cons 'menu-bar-lines (if menu-bar-mode 1 0))
+                   default-frame-alist))))
+   
+   ;; Apply it to existing frames.
+   (let ((frames (frame-list)))
+     (while frames
+       (let ((height (cdr (assq 'height (frame-parameters (car frames))))))
+         (modify-frame-parameters (car frames)
+                                  (list (cons 'menu-bar-lines
+                                              (if menu-bar-mode 1 0))))
+         (modify-frame-parameters (car frames)
+                                  (list (cons 'height height))))
+       (setq frames (cdr frames)))))
+ 
+ (defconst ns-proto-call-service
+   '((arg)
+     (interactive "p")
+     (let* ((in-string (if mark-active
+                           (buffer-substring (region-beginning) (region-end))))
+            (out-string (ns-perform-service service in-string)))
+       (cond
+        ((and out-string (or (not in-string)
+                             (not (string= in-string out-string))))
+         (if mark-active (delete-region (region-beginning) (region-end)))
+         (insert-string out-string)
+         (setq deactivate-mark nil))))))
+   
+ (defun ns-define-service (path)
+   (let ((mapping [menu-bar services])
+         (service (mapconcat 'identity path "/"))
+         (name (intern
+                (mapconcat '(lambda (s) (if (= s 32) "-" (char-to-string s)))
+                           (mapconcat 'identity (cons "ns-service" path) "-")
+                           ""))))
+     (eval (append (list 'defun name)
+                   (subst service 'service ns-proto-call-service)))
+     (cond
+      ((lookup-key global-map mapping)
+       (while (cdr path)
+         (setq mapping (vconcat mapping (list (intern (car path)))))
+         (if (not (keymapp (lookup-key global-map mapping)))
+             (define-key global-map mapping
+               (cons (car path) (make-sparse-keymap (car path)))))
+         (setq path (cdr path)))
+       (setq mapping (vconcat mapping (list (intern (car path)))))
+       (define-key global-map mapping (cons (car path) name))))
+     name))
+ 
+ (provide 'ns-menu-bar)
+ (provide 'menu-bar)
+ 
+ ;;;; ns-menu-bar.el ends here
Index: emacs/lisp/ns-scroll-bar.el
diff -c /dev/null emacs/lisp/ns-scroll-bar.el:1.1
*** /dev/null	Fri Aug  2 20:40:42 1996
--- emacs/lisp/ns-scroll-bar.el	Wed Jul 24 04:22:33 1996
***************
*** 0 ****
--- 1,125 ----
+ ;;; ns-scroll-bar.el --- NS scroll bar support.
+ 
+ ;;; Copyright (C) 1993 Free Software Foundation, Inc.
+ 
+ ;; Maintainer: FSF
+ ;; Keywords: hardware
+ 
+ ;;; This file is part of GNU Emacs.
+ 
+ ;;; GNU Emacs is free software; you can redistribute it and/or modify
+ ;;; it under the terms of the GNU General Public License as published by
+ ;;; the Free Software Foundation; either version 2, or (at your option)
+ ;;; any later version.
+ 
+ ;;; GNU Emacs is distributed in the hope that it will be useful,
+ ;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
+ ;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ ;;; GNU General Public License for more details.
+ 
+ ;;; You should have received a copy of the GNU General Public License
+ ;;; along with GNU Emacs; see the file COPYING.  If not, write to
+ ;;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ 
+ ;;; Code:
+ 
+ ;;; Commentary:
+ 
+ ;; NS bindings of mouse clicks on the scroll bar.
+ ;;; Code:
+ 
+ (require 'mouse)
+ 
+ 
+ ;;;; Utilities.
+ 
+ (defun scroll-bar-scale (num-denom whole)
+   "Given a pair (NUM . DENOM) and WHOLE, return (/ (* NUM WHOLE) DENOM).
+ This is handy for scaling a position on a scroll bar into real units,
+ like buffer positions.  If SCROLL-BAR-POS is the (PORTION . WHOLE) pair
+ from a scroll bar event, then (scroll-bar-scale SCROLL-BAR-POS
+ \(buffer-size)) is the position in the current buffer corresponding to
+ that scroll bar position."
+   ;; We multiply before we divide to maintain precision.
+   ;; We use floating point because the product of a large buffer size
+   ;; with a large scroll bar portion can easily overflow a lisp int.
+   (truncate (/ (* (float (car num-denom)) whole) (cdr num-denom))))
+ 
+ 
+ ;;;; Helpful functions for enabling and disabling scroll bars.
+ 
+ (defun scroll-bar-mode (flag)
+   "Toggle display of vertical scroll bars on each frame.
+ This command applies to all frames that exist and frames to be
+ created in the future.
+ With a numeric argument, if the argument is negative,
+ turn off scroll bars; otherwise, turn on scroll bars."
+   (interactive "P")
+   (if flag (setq flag (prefix-numeric-value flag)))
+ 
+   ;; Obtain the current setting by looking at default-frame-alist.
+   (let ((scroll-bar-mode
+ 	 (let ((assq (assq 'vertical-scroll-bars default-frame-alist)))
+ 	   (if assq (cdr assq) t))))
+ 
+     ;; Tweedle it according to the argument.
+     (setq scroll-bar-mode (if (null flag) (not scroll-bar-mode)
+ 			    (or (not (numberp flag)) (>= flag 0))))
+ 
+     ;; Apply it to default-frame-alist.
+     (mapcar
+      (function
+       (lambda (param-name)
+ 	(let ((parameter (assq param-name default-frame-alist)))
+ 	  (if (consp parameter)
+ 	      (setcdr parameter scroll-bar-mode)
+ 	    (setq default-frame-alist
+ 		  (cons (cons param-name scroll-bar-mode)
+ 			default-frame-alist))))))
+      '(vertical-scroll-bars horizontal-scroll-bars))
+ 
+     ;; Apply it to existing frames.
+     (let ((frames (frame-list)))
+       (while frames
+ 	(modify-frame-parameters
+ 	 (car frames)
+ 	 (list (cons 'vertical-scroll-bars scroll-bar-mode)
+ 	       (cons 'horizontal-scroll-bars scroll-bar-mode)))
+ 	(setq frames (cdr frames))))))
+ 
+ ;;;; Buffer navigation using the scroll bar.
+ 
+ (defun ns-scroll-bar-move (event)
+   "Scroll the frame according to a NS scroller event."
+   (interactive "e")
+   (let* ((pos (event-end event))
+          (window (nth 0 pos))
+          (scale (nth 2 pos))
+          (old-window (selected-window)))
+ ;    (prin1 (cons window (nth 2 pos)))
+     (select-window window)
+     (set-buffer (window-buffer window))
+     (cond
+      ((eq (car scale) (cdr scale))
+       (goto-char (point-max))
+       (beginning-of-line)
+       (recenter -1))
+      ((= (car scale) 0)
+       (goto-char (point-min))
+       (beginning-of-line)
+       (recenter 0))
+      (t
+       (goto-char (+ (point-min) 1
+                     (scroll-bar-scale scale (- (point-max) (point-min)))))
+       (beginning-of-line)
+       (recenter 0)))
+     (select-window old-window)))
+ 
+ 
+ ;;;; Bindings.
+ 
+ (global-set-key [vertical-scroll-bar] 'ns-scroll-bar-move)
+ 
+ (provide 'ns-scroll-bar)
+ 
+ ;;; ns-scroll-bar.el ends here
